/*******************************************************************************
*                                                                              *
*                                   Viewmol                                    *
*                                                                              *
*                               N O R M O D . C                                *
*                                                                              *
*                 Copyright (c) Joerg-R. Hill, December 1997                   *
*                                                                              *
********************************************************************************
*
* $Id: normod.c,v 1.2 1998/01/26 00:48:55 jrh Exp jrh $
* $Log: normod.c,v $
* Revision 1.2  1998/01/26 00:48:55  jrh
* Release 2.1
*
* Revision 1.1  1996/12/10  18:42:41  jrh
* Initial revision
*
*/
#include<X11/Intrinsic.h>
#ifdef __osf__
#include<X11/GLw/GLwMDrawA.h>
#else
#include<GL/GLwMDrawA.h>
#endif
#include "viewmol.h"

extern void drawMolecule(Widget, caddr_t, caddr_t);
extern void calcInternal(int);

extern struct ATOM *atoms;
extern double *cnm;
extern double amplitude;
extern int na, nmodes, mode, existsUnitCell, ninternal;

Boolean normalMode(XtPointer data)
{
  static int j=1, k=0;
  double fac;
  register int i, l, n;

/*if ((int)data == 1)
  {
    j=1;
    k=0;
  }*/
  fac=(double)j*amplitude*0.05;
  l=0;
  n=na;
  if (existsUnitCell) n-=8;
  for (i=0; i<n; i++)
  {
    atoms[i].x+=fac*cnm[mode+nmodes*l];
    atoms[i].y+=fac*cnm[mode+nmodes*(l+1)];
    atoms[i].z+=fac*cnm[mode+nmodes*(l+2)];
    l+=3;
  }
  if (j < 0) k--;
  else       k++;
  if (abs(k) == 5) j=-j;
  for (i=0; i<ninternal; i++)
    calcInternal(i);
  drawMolecule((Widget)NULL, (caddr_t)NULL, (caddr_t)NULL);
  return(False);
}
